<!---
	Name         : ping
	Author       : Rob Gonda
	Created      : December 16, 2005
	Last Updated : 
	History      : added generic XML-RPC ping (rg 12/22/05)
				 : modified pingAggregators to use XML-RPC pings (rg 12/22/05)
	Purpose		 : Ping
--->
<cfcomponent displayName="Ping" output="false">

	<!--- Code modified by Rob Gonda --->
	<cffunction name="pingAggregators" access="public" returnType="void" output="false" 
				hint="Pings blog aggregators.">
		<cfargument name="pingurls" type="string" required="true">
		<cfargument name="blogtitle" type="string" required="true">
		<cfargument name="blogurl" type="string" required="true">
		
		<cfset var aURL = "">

		<cfloop index="aURL" list="#arguments.pingurls#">

			<cfswitch expression="#aURL#">
				<cfcase value="@technorati" delimiters=",">
					<cfset pingXMLRPC(
							methodName="weblogUpdates.ping",
							rpcurl="http://rpc.technorati.com/rpc/ping",
							rpcport="80",
							blogurl="#arguments.blogurl#",
							blogtitle="#arguments.blogtitle#") />
				</cfcase>
				<cfcase value="@weblogs" delimiters=",">
					<cfset pingXMLRPC(
							methodName="weblogUpdates.ping",
							rpcurl="http://rpc.weblogs.com/RPC2",
							rpcport="80",
							blogurl="#arguments.blogurl#",
							blogtitle="#arguments.blogtitle#") />
				</cfcase>
				<cfcase value="@icerocket" delimiters=",">
					<cfset pingXMLRPC(
							methodName="weblogUpdates.ping",
							rpcurl="http://rpc.icerocket.com/",
							rpcport="10080",
							blogurl="#arguments.blogurl#") />
				</cfcase>
				<cfcase value="@blogdigger" delimiters=",">
					<cfset pingXMLRPC(
							methodName="weblogUpdates.ping",
							rpcurl="http://www.blogdigger.com/RPC2",
							rpcport="80",
							blogurl="#arguments.blogurl#",
							blogtitle="#arguments.blogtitle#") />
				</cfcase>
				<cfcase value="@blo.gs" delimiters=",">
					<cfset pingXMLRPC(
							methodName="weblogUpdates.ping",
							rpcurl="http://ping.blo.gs",
							rpcport="80",
							blogurl="#arguments.blogurl#",
							blogtitle="#arguments.blogtitle#") />
				</cfcase>
				<cfcase value="@yahoo" delimiters=",">
					<cfset pingXMLRPC(
							methodName="weblogUpdates.ping",
							rpcurl="http://api.my.yahoo.com/RPC2",
							rpcport="80",
							blogurl="#arguments.blogurl#",
							blogtitle="#arguments.blogtitle#") />
				</cfcase>
				<cfcase value="@moreover" delimiters=",">
					<cfset pingXMLRPC(
							methodName="weblogUpdates.ping",
							rpcurl="http://api.moreover.com/RPC2",
							rpcport="80",
							blogurl="#arguments.blogurl#",
							blogtitle="#arguments.blogtitle#") />
				</cfcase>
				<cfdefaultcase>
					<cfhttp url="#aURL#" method="GET" resolveurl="false">
				</cfdefaultcase>
			</cfswitch>
		</cfloop>
	   
	</cffunction>	

	
	<!---
		Name         : pingXMLRPC
		Author       : Rob Gonda
		Created      : December 22, 2005
		Last Updated : 
		History      : 
		Purpose		 : Generic XML RPC pings
	--->
	<cffunction name="pingXMLRPC" output="false" returnType="void" access="public" hint="Ping an XML-RPC interface">
					
	    <cfargument name="methodName" type="string" required="true" default="weblogUpdates.ping"> <!--- usually: 'weblogUpdates.ping' or 'weblogUpdates.extendedPing' --->
	    <cfargument name="rpcurl" type="string" required="true">
	    <cfargument name="rpcport" type="numeric" required="true" default="80">
	    <cfargument name="blogurl" type="string" required="true">
	    <cfargument name="blogtitle" type="string" required="false">
	    <cfargument name="blogcheckurl" type="string" required="false"> <!--- only included for 'weblogUpdates.extendedPing' --->
	    <cfargument name="blogrssurl" type="string" required="false"> <!--- only included for 'weblogUpdates.extendedPing' --->
		
	    
		<cfset var pingData = "" />
		<cfset var pingDataLen = "" />
		<cfset var isOK = false />
		<cfset var iceRocketResponse = "" />
		<cfset var pingResultString = "" />
		
		<cfoutput>
			<cfsavecontent variable="pingData">
		      <?xml version="1.0"?>
		      <methodCall>
		       <methodName>#arguments.methodName#</methodName>
				<params>
					<cfif structKeyExists(arguments, 'blogtitle') and len(arguments.blogTitle)><param><value>#arguments.blogTitle#</value></param></cfif>
					<param><value>#arguments.blogURL#</value></param>
					<cfif structKeyExists(arguments, 'blogcheckurl') and len(arguments.blogcheckurl)><param><value>#arguments.blogcheckurl#</value></param></cfif>
					<cfif structKeyExists(arguments, 'blogrssurl') and len(arguments.blogrssurl)><param><value>#arguments.blogrssurl#</value></param></cfif>
				</params>
		      </methodCall>
			</cfsavecontent>
		</cfoutput>
		
		<cfset pingData = trim(pingData) />
		<cfset pingDataLen = len(pingData) />

		<cfhttp method="post" url="#arguments.rpcurl#" port="#arguments.rpcport#" timeout="1" throwonerror="false">
		   <cfhttpparam type="HEADER" name="User_Agent" value="BlogCFC" />
		   <cfhttpparam type="HEADER" name="Host" value="#cgi.http_host#" />
		   <cfhttpparam type="HEADER" name="Content-Length" value="#pingDataLen#" />
		   <cfhttpparam type="XML" value="#pingData#" />
		</cfhttp>

	</cffunction>
</cfcomponent>